<script>
import { mapActions, mapGetters, mapState } from 'vuex'

import PipelineSchedules from '@/components/pipelines/PipelineSchedules'

import RouterViewLayout from '@/views/RouterViewLayout'

export default {
  name: 'Pipelines',
  components: {
    PipelineSchedules,
    RouterViewLayout
  },
  data() {
    return {
      isLoading: true
    }
  },
  computed: {
    ...mapGetters('orchestration', ['getHasPipelines', 'getSortedPipelines']),
    ...mapState('plugins', ['installedPlugins']),
    getModalName() {
      return this.$route.name
    },
    hasExtractors() {
      return (
        this.installedPlugins.extractors &&
        this.installedPlugins.extractors.length
      )
    },
    isModal() {
      return this.$route.meta.isModal
    }
  },
  created() {
    Promise.all([this.getPipelineSchedules(), this.getInstalledPlugins()]).then(
      () => {
        this.isLoading = false
      }
    )
  },
  methods: {
    ...mapActions('orchestration', ['getPipelineSchedules']),
    ...mapActions('plugins', ['getInstalledPlugins'])
  }
}
</script>

<template>
  <router-view-layout>
    <div class="container view-body is-widescreen">
      <div class="columns">
        <div class="column">
          <h2 id="data" class="title">Pipelines</h2>
        </div>
        <div class="column is-one-quarter has-text-right">
          <router-link
            :to="{
              name: 'createPipelineSchedule'
            }"
            class="button is-interactive-primary"
          >
            Create
          </router-link>
        </div>
      </div>
      <div class="columns">
        <div class="column">
          <div v-if="isLoading" class="box">
            <progress class="progress is-small is-info"></progress>
          </div>
          <div v-else>
            <PipelineSchedules
              v-if="getHasPipelines"
              :pipelines="getSortedPipelines"
            />
            <div v-else class="box">
              <p>
                No pipelines have been set up yet.
                <router-link
                  v-if="hasExtractors"
                  :to="{
                    name: 'createPipelineSchedule'
                  }"
                >
                  Create one now
                </router-link>
                <router-link v-else to="extractors"
                  >Add an extractor</router-link
                >
              </p>
            </div>
          </div>
        </div>
      </div>

      <div v-if="isModal">
        <router-view :name="getModalName"></router-view>
      </div>
    </div>
  </router-view-layout>
</template>

<style lang="scss"></style>
